#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <linux/unistd.h>
#include <sys/klog.h>
#include <syslog.h>

/*  Close the log.  Currently a NOP. */
#define SYSLOG_ACTION_CLOSE          0
/*  Open the log. Currently a NOP. */
#define SYSLOG_ACTION_OPEN           1
/*  Read from the log. */
#define SYSLOG_ACTION_READ           2
/*  Read all messages remaining in the ring buffer. */
#define SYSLOG_ACTION_READ_ALL       3
/*  Read and clear all messages remaining in the ring buffer */
#define SYSLOG_ACTION_READ_CLEAR     4
/*  Clear ring buffer. */
#define SYSLOG_ACTION_CLEAR          5
/*  Disable printk's to console */
#define SYSLOG_ACTION_CONSOLE_OFF    6
/*  Enable printk's to console */
#define SYSLOG_ACTION_CONSOLE_ON     7
/*  Set level of messages printed to console */
#define SYSLOG_ACTION_CONSOLE_LEVEL  8
/*  Return number of unread characters in the log buffer */
#define SYSLOG_ACTION_SIZE_UNREAD    9
/*  Return size of the log buffer */
#define SYSLOG_ACTION_SIZE_BUFFER   10

#define	MB	1024*1024
#define BUFFER_SIZE	2*MB
int main(int argc, char **argv)
{
	int ret = 0;
	char* buf0= malloc(BUFFER_SIZE);
	do {
		memset(buf0, 0, BUFFER_SIZE);
		ret = klogctl(SYSLOG_ACTION_READ, buf0, BUFFER_SIZE);
		if (ret < 0) {
			ret = -1;
		} else {
			printf("SYSLOG_ACTION_READ content is:\n%s", buf0);
		}
	}while(ret > 0);
	free(buf0);
	return ret;
}
